-- 试炼副本
checkRequire("Lua_TrialPanel")
Lua_TrialWindow = class("Lua_TrialWindow", Lua_Window);
function Lua_TrialWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.MAIN_MENU_LAYER;
	self.windowName = "Lua_TrialWindow";
	self.winBgPath = "/images/common/ui_common_bg_001.jpg";
	self.showWinBg = true;
	self.isFullSizeWin = true;
	self.isFullPaving = true;
	self.showBackBtn = true;
end

function Lua_TrialWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.btnList = Lua_DragList.new(self.content, 720, 127, Lua_AxisDefine.Horizontal);
	self.btnList:setListCell(Lua_TrialBtnItem, 228, 127, 1);
	self.btnList:setSiblingIndex(1);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(0, 175, 0);

	self:addLuaEvent("TRIAL_PANEL_CECLICK", self, self.selectPanel);
end

function Lua_TrialWindow:showWin(param)
	self:superCall("showWin", param);

	local openIndex = nil;
	if type(param) == "table" and param.type ~= nil then
		openIndex = param.type;
	-- elseif type(param) == "string" or type(param) == "number" then
	-- 	openIndex = tonumber(param);
	end

	-- 没有指定显示那个页签时，默认显示有红点的页签
	local showArr = DataCenter.TrialData:getTrialTypeArr();
	if showArr ~= nil and showArr:getSize() > 0 and openIndex == nil then
		local redDotState;
		for i = 1, showArr:getSize() do
			redDotState = DataCenter.redPointData:getRedPointStateById(showArr[i].redPointId);
			if redDotState then
				openIndex = i;
				break;
			end
		end
	end
	openIndex = openIndex == nil and 1 or openIndex;

	if DataCenter.TrialData.fightToShowType then
		openIndex = DataCenter.TrialData.fightToShowType;
		DataCenter.TrialData.fightToShowType = nil;
	end
	self:setShowInfo(openIndex);
end

function Lua_TrialWindow:setShowInfo(openIndex)
	local showArr = DataCenter.TrialData:getTrialTypeArr();
	self.btnList.canDrag = showArr:getSize() > 3;
	self.btnList:setArrayData(showArr);
	self.btnList:moveToIndex(openIndex, true);
	self.btnList:setSelectClick(openIndex);
	self.btnList:setSelected(openIndex);
end

function Lua_TrialWindow:selectPanel(val)
	if self.selectType == val then
		return;
	end
	self.selectType = val;

	if self.curPanel == nil then
		self.curPanel = Lua_TrialPanel.new(self.content, val);
		self.curPanel:setSiblingIndex(1);
		self.curPanel:setRectAnchor(9);
	end
	self.curPanel:setType(val);
	Lua_ProxyManager.getProxy("Lua_TrialProxy"):sTrialTypeInfo(val);
end

function Lua_TrialWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1035, true);
end

function Lua_TrialWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TrialBtnItem = class("Lua_TrialBtnItem", Lua_ListCell);
function Lua_TrialBtnItem:ctor(p)
	self:superCall("ctor", p, "TrialBtn_skin");
end

function Lua_TrialBtnItem:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("UPDATE_TRIAL_TYPE_INFO", self, self.updateShowFun);
end

function Lua_TrialBtnItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.bg:setAltas(data.trialIcon[1], data.trialIcon[2]);

	if data.game_level_id ~= nil then
		local config = Lua_MainLineCheckpointConfigData.getConfig(data.game_level_id);
		self.openCondTxt.text = LanUtil.formateStr(200612, config.name);
	else
		self.openCondTxt.text = LanUtil.formateStr(200610, data.open_level);
	end

	if self.redPointIcon == nil then
		self.redPointIcon = Lua_RedPointIcon.new(self.content, data.redPointId);
		self.redPointIcon:setLocation(100, 50, 0);
	else
		self.redPointIcon:changeRedPoint(data.redPointId);
	end
	self:updateShowFun(data.id);
end

function Lua_TrialBtnItem:updateShowFun(trialType)
	-- print(trialType, self.data.id, self.data.open_id, self.data.open_state);
	if self.data.id == trialType then
		self.openCondTxt:setEnable(not self.data.open_state);
		self.openCondBg:setEnable(not self.data.open_state);
		self.mask:setEnable(not self.data.open_state);
	end
end

function Lua_TrialBtnItem:onPressClick()
	if DataCenter.funcOpenData:isOpened(self.data.open_id, true) then
		DataCenter.TrialData.curShowType = self.data.id;
		Lua_MsgUtil.callFunc("TRIAL_PANEL_CECLICK", self.data.id);
		return true;
	end
	return false;
end

function Lua_TrialBtnItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	self.selectIocn:setEnable(bSelect);
end

function Lua_TrialBtnItem:dispose()
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end